//+------------------------------------------------------------------+
//|                                             Non_const_method.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property strict
#property indicator_separate_window
//
class c_WorkingBarValues
 {
   private:
      ENUM_TIMEFRAMES indiTF;
      datetime firstBarTime;
   public:
      void c_WorkingBarValues(void)
       {
         indiTF = PERIOD_H1;
         setFirstBarTime();
       }
      ENUM_TIMEFRAMES getIndiTF(void) { return(indiTF); }
      datetime getFirstBarTime(void) { return(firstBarTime); }
      void setFirstBarTime(void) { firstBarTime = iTime(_Symbol,getIndiTF(),iBarShift(_Symbol,getIndiTF(),Time[Bars-1],false)); }
 } *workingBarValues = NULL;
//
class c_Signals
 {
   private:
      int barNum;
   public:
      void c_Signals(void)
       {
         barNum=0;
       }
      void setBarNum( const c_WorkingBarValues* barInfo )  // this compiles: setBarNum( c_WorkingBarValues* const barInfo )
       {
         barNum = iBarShift(_Symbol,barInfo.getIndiTF(),barInfo.getFirstBarTime(),false);
       }
      int getBarNum(void){ return(barNum); }
 } *signals = NULL;
//
int OnInit()
 {
   workingBarValues = new c_WorkingBarValues();
   signals          = new c_Signals();
   return(INIT_SUCCEEDED);
 }
//
void OnDeinit(const int reason)
 {
   delete workingBarValues;
   delete signals;
   Comment("");
 }
//
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &time[], const double &open[], const double &high[],
                const double &low[], const double &close[], const long& tick_volume[], const long& volume[], const int& spread[] )
 {
   signals.setBarNum( workingBarValues );
   Comment( "First Bar Num is: "+IntegerToString(signals.getBarNum()) );
   return(rates_total);
 }
//+------------------------------------------------------------------+
